SystemOrganization addCategory: #'GBT-DSL_EFA'!

Object subclass: #Auswertungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Auswertungen class methodsFor: 'contexts' stamp: 'hk 11/7/2016 17:27'!
auswertungenContext: userName 
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'Auswertungen'  for: userName define: {
		{#displayAs: . 'Auswertungen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16} .
		{#templates: . self fahrtContext: userName } .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(bootsName Boot) #(steuermann Steuermann) #(abfahrt Abfahrt))} .
		{#subcontext: . self fahrtContext: userName }
		}
! !

Object subclass: #EFA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!EFA class methodsFor: 'contexts' stamp: 'hk 1/9/2017 18:32'!
efa: arg1
	^ GbtPlainAC newStruct: #EFA for: arg1 define:
			{{#aspect:on:. (Fahrtenbuch fahrtenBuchContext: arg1). nil}.
			{#aspect:on:. (Boote booteContext: arg1). nil}.
			{#aspect:on:. (Personen personenContext: arg1). nil}.
			{#aspect:on:. (Beitragsmanagement beitragsmanagementContext: arg1). nil}.
			{#aspect:on:. (Statistics statisticsContext: arg1). nil}.
			{#uiSpec:icon: . #GbtMainUI . #efa}.
			{#displayAs: . #EFA}.
			{#extent:. (1200 @ 800)}.
			{#legalText: . 'GloConn International © 2016'}}! !

!EFA class methodsFor: 'example' stamp: 'hk 1/26/2017 18:33'!
exampleClear
	GbtAppService clearStore. 
	GbtSVO initialize. 
! !

!EFA class methodsFor: 'example' stamp: 'hk 8/18/2016 16:45'!
exampleData
	self storeTestFahrten.
	self storeTestPersonen.
	self storeTestBoote.
	self storeTestBeitragstabellen.
"	self storeBeitragsmanagement.
	self storeBeitragsabrechnungen.
"	! !

!EFA class methodsFor: 'example' stamp: 'hk 11/11/2016 13:54'!
exampleRun
	self login open
! !

!EFA class methodsFor: 'contexts' stamp: 'hk 1/26/2017 18:33'!
installUsers
		#(Tom Lisa) do: [:u| GbtAppService default addUser: u withRole: GbtRole forExecute ].
		#(Tony Robert) do: [:u| GbtAppService default addUser: u withRole: GbtRole forWrite ].
		#(Bob) do: [:u| GbtAppService default addUser: u withRole: GbtRole forRead ]! !

!EFA class methodsFor: 'contexts' stamp: 'hk 11/21/2016 20:25'!
login
	self installUsers.
	^ GbtLoginAC newStruct: 'EFALogin' for: '' define:
			{{#uiSpec:icon: . nil . #efa}.
			{#displayAs: . #EFA}.
			{#appClass:selector: . #EFA . #efa:}.
			{#legalText: . 'GloConn International © 2016'}}! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:53'!
storeBeitragsmanagement
	Beitragsmanagement beitragsmanagement01
! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 18:52'!
storeTestBeitragstabellen
	Beitragstabellen beitragstabellenliste1! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 18:07'!
storeTestBoote
	Boote booteListe1! !

!EFA class methodsFor: 'example' stamp: 'hk 8/11/2016 12:58'!
storeTestFahrten
	Fahrtenbuch  storeTestFahrten! !

!EFA class methodsFor: 'test data' stamp: 'CC 8/7/2016 17:45'!
storeTestPersonen
	Personen personenListe1
! !

Object subclass: #Fahrtenbuch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 8/21/2016 19:09'!
besatzung
	"self besatzung edit"
	^GbtThing newStruct: 'Besatzung' define: {
		{ #summary . 'system template'}.
		{ #Steuermann . #thing: .  self ruderer}.
		{ #Mannschaft . #listOf: .  self ruderer}.
	}! !

!Fahrtenbuch class methodsFor: 'examples' stamp: 'hk 1/26/2017 18:33'!
exampleRun
	GbtAppService initialize. GbtSVO initialize.
	(self fahrtenBuchContext: '') ui title: #Fahrtenbuch; open! !

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 8/19/2016 11:54'!
fahrt
	"self fahrt edit"
	^GbtThing newStruct: 'Fahrt' define: {
	 	{ #summary . '#bizId : #Steuermann:RudererName #Mannschaft ab: #Abfahrt an: #Ankunft' }.
		{ #idNumberPolicy . #FahrtNoPolicy }.
		{ #Datum . #date: . Date today}.
		{ #Boot . #thing: .  Boote boot}.
		{ #Besatzung . #thing: .  self besatzung}.
		{ #Abfahrt . #date: . '1 July 2016' }.
		{ #Ankunft . #date: . '2 July 2016' }.
		{ #Ziel . #enum: .  #(Fluss Mündung)}.
		{ #Kilometer . #no: .  0}.
	} full: { 
		{ #Bemerkung . #text: . ''}.	
		{ #FahrtArt . #enum: . #(NormaleFahrt Trainingsfahrt Wanderfahrt)}.			
	}! !

!Fahrtenbuch class methodsFor: 'contexts' stamp: 'hk 12/14/2016 16:54'!
fahrtContext: userName 
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'FahrtContext'  for: userName define: {
		{#displayAs: . 'Fahrt'  } .
		{#uiSpec:icon: . #GbtItemUI . #rowingTeam}.
		{#chooseFor:from: . #Boot . Boote booteContext: userName  }.
		{#chooseFor:use:from: . #Steuermann . self rudererDeclarative . Personen personenContext: userName }.
		{#chooseFor:use:from: . #Mannschaft . self rudererDeclarative . Personen personenContext: userName  }.
		}
! !

!Fahrtenbuch class methodsFor: 'contexts' stamp: 'hk 1/12/2017 18:57'!
fahrtenBuchContext: userName 
	"comment stating purpose of message"
	
	^GbtBigListAC newStruct: 'FahrtenBuchContext'  for: userName define: {
		{#displayAs: . 'FahrtenBuch'} .
		{#noPolicyPrefix: . 'Fahrt'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #rowingTeam} .
		{#templates: . self fahrt} .
		{#filterBy: . #(Bootsname RudererName) } .						
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Bootsname Boot) #(RudererName Steuermann) Abfahrt)} .
		{#subcontext: . self fahrtContext: userName }
		}
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 1/26/2017 18:33'!
nextBizID
	^GbtAppService default nextIdOfContextNoPolicy: #FahrtenBuchContext! !

!Fahrtenbuch class methodsFor: 'things' stamp: 'hk 8/11/2016 12:51'!
ruderer
	"self ruderer edit"
	
	^GbtThing newStruct: 'Ruderer' define: {
		{ #summary . '#RudererName , #RudererVorname' }.
		{ #purposes . #(Steuermann Ruderer) }.
		{ #RudererName . #val: . ''}.
		{ #RudererVorname . #val: .  ''}.
		{ #SportlerId . #val: .  ''}.
	} full: { 
		{ #FremdVerein. #val: . ''}.					
	}! !

!Fahrtenbuch class methodsFor: 'declaratives' stamp: 'CC 7/22/2016 15:15'!
rudererDeclarative
	^GbtDeclarative newStruct: 'RudererDeclarative' define: { 
		{ #RudererName . #tag: . #Nachname }.
		{ #RudererVorname . #tag: . #Vorname }.
		{ #SportlerId . #tag: .  #bizId}.
		{ #FremdVerein }.					
	} ! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 1/26/2017 18:33'!
storeTestFahrten
	"Diese Methode erzeugt die noPolicy für Boote vorab"
	GbtAppService default contextNoPolicyOf: #FahrtenBuchContext prefix: #Fahrt.
	self testFahrt1 store.	
	self testFahrt2 store.
	self testFahrt3 store.
	self testFahrt4 store.	
	self testFahrt5 store.
	self testFahrt6 store.! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt1
	^Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer1;
		Kilometer: 20;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt2
	^Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer2;
		Kilometer: 28;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt3
	^Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Alster;
		Steuermann: self testRuderer3;
		Kilometer: 30;
		yourself
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:06'!
testFahrt4
	| aFahrt |
	aFahrt := Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 99;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer1 .
	^aFahrt

! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:07'!
testFahrt5
	| aFahrt |
	aFahrt := Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 77;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer2.
	^aFahrt
! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/30/2016 14:07'!
testFahrt6
	| aFahrt |
	aFahrt := Fahrtenbuch fahrt 
		bizId: self nextBizID;
		Bootsname: #Elbe;
		Steuermann: self testRuderer3;
		Kilometer: 66;
		yourself.
	aFahrt Mannschaft newEntry: self testRuderer3.
	^aFahrt 

! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/29/2016 15:16'!
testRuderer1
	^Fahrtenbuch ruderer
		RudererName: #Schmidt1;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/29/2016 15:16'!
testRuderer2
	^Fahrtenbuch ruderer
		RudererName: #Schmidt2;
		RudererVorname: #Henning;
		yourself! !

!Fahrtenbuch class methodsFor: 'test data' stamp: 'hk 11/29/2016 15:17'!
testRuderer3
	^Fahrtenbuch ruderer
		RudererName: #Schmidt3;
		RudererVorname: #Henning;
		yourself! !

Object subclass: #Finanzen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Finanzen subclass: #Beitragsabrechnung
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 8/21/2016 19:15'!
abrechnungszeitraum
	"self abrechnungszeitraum edit"
	
	^GbtThing newStruct: 'Abrechnungszeitraum' define: {
		{ #summary . 'system template' }.
		{ #Von . #date: . Date current}.
		{ #bis . #date: . Date current}.	
	} full: { 
	}! !

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 8/18/2016 17:22'!
beitrag
	"self beitrag edit"
	
	^GbtThing newStruct: 'Beitrag' define: {
		{ #summary .  '#Nachname #Vorname EUR #Betrag'}.	
		{ #Berechnungsdatum . #date: . Date current}.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: . ''}.
		{ #Mitgliedsnummer . #val: . ''}.
		{ #FamilienOberhaupt . #enum: . #(false true) }.	
		{ #Mitgliedstatus . #enum: .  #(aktiv passiv) }.	
		{ #Beitragstatus . #enum: . #(Erwachsener 'Nichtverdiener14plus' 'Kind14minus')}.	
		{ #Familienname . #val: . ''}.
		{ #FamilienmitgliedNr . #no: . 1}.
		{ #normalBeitrag . #no: . 0}.
		{ #Familienrabatt . #no: . 0}.
		{ #Mindestbeitrag . #no: . 0}.
		{ #ermBeitrag . #no: . 0}.
		{ #beitrag . #no: . 0}.
		{ #Betrag . #no: . 0}.
		{ #Währung . #val: . 'EUR'}.
		{ #vz . #val: . '' }.
		{ #rz . #val: . ''}.
		{ #az . #no: . 1 }.
		{ #Rechnungserzeugung . #enum: . #(false true)}.
		{ #Fälligkeit . #date: . Date current}.	
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 11/7/2016 17:19'!
beitragContext: userName 
	"self beitragContext edit"

	^GbtPlainAC newStruct: 'BeitragContext'  for: userName define: {
		{#displayAs: . 'Beitrag'  } .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16}
		}
! !

!Beitragsabrechnung class methodsFor: 'declaratives' stamp: 'hk 8/25/2016 17:15'!
beitragDecl
	"Input Person & Beitragstabelle mit beitragXLS"

	^GbtDeclarative newStruct: 'Beitrag' define: { 
		{ #Berechnungsdatum }.
	"von Person"
		{ #Nachname }.
		{ #Vorname }.
		{ #Mitgliedsnummer . #tag: . #bizId }.
		{ #FamilienOberhaupt }.	
		{ #Mitgliedstatus }.	
		{ #Beitragstatus }.	
		{ #Familienname }.
		{ #FamilienNummer }.
		{ #FamilienmitgliedNr }.	
	"von Beitragstabelle"
		{ #aktiv}.
		{ #passiv}.
		{ #Familienrabatt }.
		{ #Mindestbeitrag }.
		{ #normalBeitrag }.
		{ #ermBeitrag }.
		{ #beitrag }.
		{ #Betrag }.
		{ #Währung }.
		{ #vz . #tag: . #vollzahler }.
		{ #rz . #tag: . #rabattiert }.
		{ #az . #tag: . #anzahl }.
	"misc"
		{ #Rechnungserzeugung }.
		{ #Fälligkeit }
		}! !

!Beitragsabrechnung class methodsFor: 'things' stamp: 'hk 8/19/2016 12:03'!
beitragsabrechnung
	"self beitragsabrechnung edit"
	
	^GbtThing newStruct: 'Beitragsabrechnung' define: {
		{ #summary .  '#Abrechnungsname #BeitragssummeGesamt'}.
		{ #idNumberPolicy . #BeitragsAbrechnungsNoPolicy }.
		{ #Abrechnungsgenauigkeit . #enum: . #(Tag Monat Halbjahr Jahr)}. "für unterjährigen Eintritt/Austritt"
		{ #Abrechnungsname . #val: . ''}.
		{ #Abrechnungszeitraum . #thing: . self abrechnungszeitraum}.
		{ #Beitragstabelle . #thing: . Beitragstabellen beitragstabelle}.
		{ #Abrechner . #val: . ''}.
		{ #Beitragsliste . #listOf: . self beitrag}.
		{ #BeitragssummeGesamt . #sum: . #beitrag}.
		{ #AnzahlVollzahler . #sum: . #vz }.
		{ #AnzahlRabattierteMitglieder . #sum: . #rz }.
		{ #AnzahlMitglieder . #sum: . #az }.
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 12/16/2016 18:29'!
beitragsabrechnungContext: userName 

	self beitragDecl.	"stellt das Declarative HKBeitrag bereit"

	^GbtPlainAC newStruct: 'BeitragsabrechnungContext' for: userName  define: {
		{#displayAs: . 'Beitragsabrechnung'} .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #beitragsMgmt16} .
		{#aspect:on: . self beitragslisteContext: userName  . #Beitragsliste } .
		{#menu:items: . #BeitraegsMenu . #('Beitragsabrechnungen erstellen' 'Einbuchen') }.
		{#behavior:actions: . #'Beitragsabrechnungen erstellen' . 
			#(MAPBL PersonenContext 
			 READSLOT #(Beitragstabelle vBTab)  
			 ALTER #( vBTab Beitrag ) 
			 FREEZE void  
			 REDUCE #(contextVO Beitragsliste) )}
	}! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 1/9/2017 20:53'!
beitragsabrechnungenContext: userName 
	"comment stating purpose of message"
	
	^GbtBigListAC newStruct: 'BeitragsabrechungenContext' for: userName  define: {
		{#displayAs: . 'Beitragsabrechnungen'} .
		{#noPolicyPrefix: . 'Abrechnung_'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16} .
		{#templates: . self beitragsabrechnung} .
		{#loadPolicy: . #autoload }.
		{#chooseFor: . #Beitragstabelle }.
		{#chooseWith: . Beitragstabellen beitragstabellenContext: userName}.
		{#display: . #( #(BeitragssummeGesamt Summe) #(AnzahlMitglieder Mitglieder) #(AnzahlVollzahler Vollzahler) #(AnzahlRabattierteMitglieder #rabattiert) )}.
		{#subcontext: . self beitragsabrechnungContext: userName }
		}
! !

!Beitragsabrechnung class methodsFor: 'contexts' stamp: 'hk 11/8/2016 11:52'!
beitragslisteContext: userName 
	"comment stating purpose of message"
	
	^GbtUlistAC newStruct: 'BeitragslisteContext'  for: userName define: {
		{#displayAs: . 'Beitragsliste'  } .
		{#uiSpec:icon: . #GbtListAndItemUI . #beitragsMgmt16}.
		{#template:for: . self beitrag . #Beitragsliste} .
		{#display: . #(Nachname Vorname Betrag)} .
		{#subcontext: . self beitragContext: userName }
		}! !

Finanzen subclass: #Beitragsmanagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragsmanagement class methodsFor: 'things' stamp: 'hk 8/18/2016 16:35'!
beitragsmanagement
	"self beitragsmanagement edit"
	
	^GbtThing newStruct: 'Beitragsmanagment' define: {
		{ #AktuellerAbrechnungszeitraum . #val: . ''}.
		{ #OffeneBeiträge . #no: . 0}.
		{ #Beitragstabellen . #thing: . Beitragstabellen beitragstabelle }.
		{ #Beitragsabrechnungen . #thing: . Beitragsabrechnung beitragsabrechnung}.
		{ #Rechnungen . #thing: . Rechnungen rechnung}.
"		{ #opListen . #thing: . self opListen}."
	} full: { 
	}! !

!Beitragsmanagement class methodsFor: 'test data' stamp: 'hk 12/14/2016 15:07'!
beitragsmanagement01
	"self beitragsmanagement01 edit"
	^(self beitragsmanagement01: self beitragsmanagement) store
! !

!Beitragsmanagement class methodsFor: 'test data' stamp: 'CC 8/12/2016 18:50'!
beitragsmanagement01: b
	"self beitragsmanagement01 edit"
	
	b Beitragstabellen: Beitragstabellen beitragsTabelle2016.
	^b! !

!Beitragsmanagement class methodsFor: 'contexts' stamp: 'hk 11/7/2016 19:24'!
beitragsmanagementContext: userName 
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'BeitragsmanagementContext' for: userName  define: {
		{#displayAs: . 'Beitragsmanagment'} .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #beitragsMgmt16} .
		{#vo: . self beitragsmanagement} .
		{#loadPolicy: . #autoload } .
		{#aspect:on: . Beitragstabellen beitragstabellenContext: userName . #Beitragstabellen } .
		{#aspect:on: . Beitragsabrechnung beitragsabrechnungenContext: userName . #Beitragsabrechnungen } .
		{#aspect:on: . Rechnungen rechnungenContext: userName . #Rechnungen } .
"		{#aspect:on: . OPListen opListenContext . #opListen } "
		{#menu:items: . #Beitragsmanagement . #(#'Do Something 1' #'Do Something 2') }.
		}
! !

!Beitragsmanagement class methodsFor: 'examples' stamp: 'hk 1/26/2017 18:33'!
exampleRun
	| ui |
	GbtAppService initialize. GbtSVO initialize.
	(ui := (self beitragsmanagementContext: '') ui) title: ('Beitragsmanagement', ui title); open! !

Finanzen subclass: #Beitragstabellen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/21/2016 19:10'!
basisBeitragAktiv
	"self HKbasisBeitragAktiv edit"
	
	^GbtThing newStruct: 'BasisBeitragAktiv' define: {
		{ #summary . 'system template' }.
		{ #Erwachsener . #no: . 230 }.
		{ #Nichtverdiener14plus . #no: . 135}.
		{ #Kind14minus . #no: . 100}.
	}! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/21/2016 19:10'!
basisBeitragPassiv
	"self BasisBeitragPassiv edit"
	
	^GbtThing newStruct: 'BasisBeitragPassiv' define: {
		{ #summary . 'system template' }.
		{ #Erwachsener . #no: . 115 }.
		{ #Nichtverdiener14plus . #no: . 115}.
		{ #Kind14minus . #no: . 115}.
	}! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 8/25/2016 18:24'!
beitragXLS
	"self HKbasisBeitrag editD"
	
	^GbtThing newStruct: 'BeitragXLS' define: {
		{ #summary . 'system template'}.
		{ #aktiv . #thing:tag: . self basisBeitragAktiv . #aktiv}.
		{ #passiv . #thing:tag: . self basisBeitragPassiv . #passiv}.
		{ #Währung . #val: . #EUR }.
		{ #Mindestbeitrag . #no: . 70.00 }.		
		{ #Familienrabatt . #no: . 0.5}.		
		{ #normalBeitrag . #lookup: . '#Mitgliedstatus #Beitragstatus' }.	
		{ #ermBeitrag . #calc: . '( #FamilienmitgliedNr asNumber = 2) ifTrue: [ #normalBeitrag asNumber* #Familienrabatt asNumber ] ifFalse: [ #Mindestbeitrag ] '}.
		{ #beitrag . #calc: . '( #FamilienOberhaupt = ''true'') ifTrue:[ #normalBeitrag ] ifFalse:[ #ermBeitrag ]' }.
		{ #Betrag . #calc: . ' #beitrag asNumber max: ( #Mindestbeitrag asNumber)' }.
		{ #vollzahler . #calc: . '( #Betrag = #normalBeitrag ) ifTrue:[1]ifFalse:[0]' }.
		{ #rabattiert . #calc: . '( #Betrag = #normalBeitrag ) ifTrue:[0]ifFalse:[1]' }.
		{ #anzahl . #no: . 1 }
	}! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:23'!
beitragsTabelle2016
	^self beitragsTabelle2016: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 11/15/2016 16:22'!
beitragsTabelle2016: t
	"self beitragsTabelle2016 editD"
	
	^t TabellenName: #Jahr_2016 ;
		GueltigkeitVon: '01.01.2016' ;
		GueltigkeitBis: '12.31.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';	
		Abrechnungsmodus: #GanzjahresAbrechnung	;
		yourself
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:28'!
beitragsTabelle2016HJ1
	^self beitragsTabelle2016HJ1: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 11/15/2016 16:22'!
beitragsTabelle2016HJ1: t
	"self beitragsTabelle2016HJ1 editD"
	
	^t TabellenName: #'1.HJ_2016' ;
		GueltigkeitVon: '01.01.2016' ;
		GueltigkeitBis: '06.30.2016';
		Mindestbeitrag: 70.00 ;		
		Familienrabatt: 0.5;		
		BeschlossenAm: '03.02.2016';		
		yourself
! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 8/18/2016 16:28'!
beitragsTabelle2016HJ2
	^self beitragsTabelle2016HJ2: self beitragstabelle! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 11/15/2016 16:22'!
beitragsTabelle2016HJ2: t
	"self beitragsTabelle2016HJ1 editD"
	
	^t TabellenName: #'2.HJ_2016' ;
		GueltigkeitVon: '07.01.2016' ;
		GueltigkeitBis: '12.31.2016';
		Mindestbeitrag: 80.00 ;		
		Familienrabatt: 0.4;		
		BeschlossenAm: '03.02.2016';		
		yourself
! !

!Beitragstabellen class methodsFor: 'things' stamp: 'hk 11/15/2016 16:18'!
beitragstabelle
	^ GbtThing newStruct: 'HKBeitragstabelle' define: {
			{#summary . '#TabellenName : #GueltigkeitVon - #GueltigkeitBis '}.
			{#idNumberPolicy . #BeitragsTabelleNoPolicy}.
			{#TabellenName . #val: . ''}.
			{#GueltigkeitVon.  #date:. Date current}.
			{#GueltigkeitBis . #date:. Date current}.
			{#Abrechnungsmodus . #enum:. #(#HalbjahresAbrechnung #GanzjahresAbrechnung)}.
			{#BeitragXLS . #thing:. self beitragXLS}.
			{#BeschlossenAm . #date: . Date current}.
			{#BeschlossenDurch . #enum: . #(#Hauptversammlung #Sonderregelung)}}! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 12/14/2016 16:54'!
beitragstabelleContext: userName 
	""
	^GbtPlainAC newStruct: 'BeitragstabelleContext'  for: userName define: {
		{#displayAs: . 'Beitragstabelle'} .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16} .
		}
! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 11/15/2016 16:19'!
beitragstabellenContext: arg1
	^ GbtBigListAC newStruct: 'BeitragstabellenContext' for: arg1 define: {
			{#displayAs: . 'Beitragstabellen'}.
			{#noPolicyPrefix: . 'BT'}.
			{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16}.
			{#templates: . self beitragstabelle}.
			{#loadPolicy: . #autoload}.
			{#display: . #(#(#TabellenName #Name) #(#GueltigkeitVon #von) #(#GueltigkeitBis #bis))}.
			{#subcontext: . self beitragstabelleContext: arg1}}! !

!Beitragstabellen class methodsFor: 'test data' stamp: 'hk 12/14/2016 15:06'!
beitragstabellenliste1
	self beitragsTabelle2016 store.
	self beitragsTabelle2016HJ1 store.
	self beitragsTabelle2016HJ2 store.! !

!Beitragstabellen class methodsFor: 'contexts' stamp: 'hk 1/26/2017 18:33'!
exampleRun
	| ui |
	GbtAppService initialize. GbtSVO initialize.
	(ui := (self beitragstabellenContext: '') ui) title: ('Beitragstabellen', ui title); open! !

Finanzen subclass: #OPListen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!OPListen class methodsFor: 'things' stamp: 'CC 8/22/2016 19:33'!
opListe
	"self OPListe edit"
	
	^GbtThing newStruct: 'opListe' define: {
		{ #summary .  '#bizId #Berechnungsdatum EUR #Beitragshöhe'}.	
		{ #idNumberPolicy  . #OPListeNoPolicy}.
		{ #Bezeichnung. #val: . ''}.
		{ #Erstellung . #enum: . #(Rechnung Storno)}.
		{ #OPListeAktuell . #listOf: . Rechnungen rechnung}.
		{ #OPSumme . #no: . 0}.
	} full: { 
	}! !

!OPListen class methodsFor: 'contexts' stamp: 'hk 12/14/2016 16:55'!
opListeContext: userName 
	""
	^GbtPlainAC newStruct: 'opListeContext'  for: userName define: {
		{#displayAs: . 'OPListe'} .
		{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16} .
		{#behavior:actions: . #'Mahnungen verschicken' . 
			#(HALT void )}
		}
! !

!OPListen class methodsFor: 'contexts' stamp: 'hk 11/7/2016 19:21'!
opListenContext: userName 
	""
	^GbtBigListAC newStruct: 'opListenContext'  for: userName define: {
		{#displayAs: . 'OPListen'} .
		{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16} .
		{#templates: . self opListe} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(bizId Rechnungsnummer) #(Rechnungsbeitrag Beitrag) )} .
		{#subcontext: . self opListeContext: userName}
		}
! !

Finanzen subclass: #Rechnungen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Rechnungen class methodsFor: 'examples' stamp: 'hk 1/26/2017 18:33'!
exampleRun
	| ui |
	GbtAppService initialize. GbtSVO initialize.
	(ui := (self rechnungenContext: '') ui) title: ('Beitragsrechnungen', ui title); open! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 16:56'!
familienConstraint
	"self familienConstraint editD"
	^GbtThing newStruct: 'FamilienConstraint' define: { 
		{ #mitglied . #constraint: . '#FamilienmitgliedNr asNumber >1'}.
		{ #familie  . #constraint: . '#FamilienNummer = #AdressatNummer'} }! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 16:52'!
oberhauptConstraint
	"self oberhauptConstraint editD"
	^GbtThing newStruct: 'OberhauptConstraint' define: { 
		{ #mitglied . #constraint: . '#FamilienmitgliedNr asNumber = 1'} }! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 15:29'!
rechnung
	"self rechnung edit"
	
	^GbtThing newStruct: 'Rechnung' define: {
		{ #summary .  '#bizId #Berechnungsdatum EUR #Beitragshöhe'}.	
		{ #idNumberPolicy  . #RechnungNoPolicy}.
		{ #Rechnungstyp . #enum: . #(Rechnung Storno)}.
		{ #Rechnungsdatum . #date: . Date current}.
		{ #Rechnungskopf . #val: . 'Absender aus Vereinsstammdaten'}.
		{ #Rechnungsadresse . #thing: . self rechnungsadresse}.
		"Decl(Beitrag) mit Name, Vorname und anderen Daten"
		{ #Rechnungspositionen . #listOf: . self rechnungsposition}.	
		{ #Rechnungsbeitrag . #sum: . #Betrag}.	
	} full: { 
		{ #Eingebucht . #enum: . #(false true)}.
		{ #Buchungsdatum . #date: . Date current}.
		{ #Fälligkeit . #date: . Date current}.
	}
! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 8/25/2016 17:13'!
rechnungBeitragDeclarative
	^GbtDeclarative newStruct: 'RechnungBeitragDecl' define: { 
		"aus Beitrag"
		{ #Berechnungsdatum }.
		{ #Nachname }.
		{ #Vorname }.
		{ #Mitgliedsnummer }.
		{ #Familienname }.
		{ #FamilienNummer }.
		{ #FamilienmitgliedNr }.
		{ #Betrag }.
		{ #Währung }.
		"aus Rechnung"
		{ #AdressatNummer }.
	} ! !

!Rechnungen class methodsFor: 'contexts' stamp: 'hk 12/16/2016 18:31'!
rechnungContext: userName
	self familienConstraint; rechnungBeitragDeclarative.
	^ GbtPlainAC newStruct: 'RechnungContext' for: userName define:
			{{#displayAs: . 'Rechnung'}.
			{#uiSpec:icon: . #GbtItemUI . #beitragsMgmt16}.
			{#behavior:arguments:actions:. #positionen. #(#v0).
				#(#NEWVO #void 
				  #READSLOT #(#Mitgliedsnummer #v2) 
				  #WRITESLOT #(#v2 #AdressatNummer) 
				  #TRANSFORM #(#thing #Rechnungsposition #v1) 
				  #ADD2L #(#v1 #Rechnungspositionen) 
				  #ASSIGN #(#contextVO #thing) 
				  #ASSIGN #(#thing #vRg) 
				  #MAP #(#v0 #Beitragsliste) 
				  #ALTER #(#vRg #RechnungBeitragDecl) 
				  #FILTER #FamilienConstraint 
				  #ALTER #(#void #Rechnungsposition) 
				  #REDADD #(#thing #Rechnungspositionen))}}! !

!Rechnungen class methodsFor: 'contexts' stamp: 'hk 11/14/2016 18:15'!
rechnungenContext: userName
	self rechnungspositionDeclarative; oberhauptConstraint.
	^ GbtBigListAC newStruct: 'RechnungenContext' for: userName define:
			{{#displayAs: . 'Rechnungen'}.
			{#noPolicyPrefix: . 'Rng'}.
			{#uiSpec:icon: . #GbtListAndItemUI . #bizoffer16}.
			{#templates:. self rechnung}.
			{#loadPolicy: . #autoload}.
			{#display:. #(#(#AdressatNummer #Mitgliedsnummer) #(#Rechnungsbeitrag #Beitrag))}.
			{#subcontext:. self rechnungContext: userName}.
			{#menu: . #Rechnungslauf}.
			{#menu: . #'Neue Rechnung'}.
			{#behavior:actions:. #Rechnungslauf.
				#(#ASKELEM #(#BeitragsabrechungenContext #v1) 
				  #MAP #(#v1 #Beitragsliste) 
				  #FILTER #OberhauptConstraint 
				  #APPLY #(#RechnungContext #positionen #v1) 
				  #REFRESH #gui)}.
			{#behavior:actions:. #'Neue Rechnung'.
				#(#ASKELEM #(#BeitragsabrechungenContext #v1) 
				  #ASSIGN #(#v1 #thing) 
				  #ASKFROM #(#Beitragsliste #thing) 
				  #BEHAVIOR #(#RechnungContext #positionen #v1) 
				  #REFRESH #gui)}}! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 15:30'!
rechnungsadresse
	"self rechnungsadresse edit"
	^GbtThing newStruct: 'Rechnungsadresse' define: { 
		{ #summary . 'system template' }.
		{ #AdressatNummer . #val: . 'bizId'}.
		{ #AdressatName . #val: . '' }.
		{ #AdressatVorname . #val: . '' }.
		{ #StraßeUndNummer . #val: . ''} .
		{ #PLZUndWohnort . #val: . ''}.					
	} ! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'CC 7/22/2016 12:31'!
rechnungsadresseDeclarative
	^GbtDeclarative newStruct: 'Rechnungsadresse' define: { 
		{ #AdressatName . #tag: . #Nachame }.
		{ #AdressatVorname . #tag: . #Vorname }.
		{ #StraßeUndNummer } .
		{ #PLZUndWohnort }.					
	} ! !

!Rechnungen class methodsFor: 'things' stamp: 'hk 8/25/2016 17:22'!
rechnungsposition
	"self rechnungsposition edit"
	^GbtThing newStruct: 'Rechnungsposition' define: { 
		{ #summary . '#Betrag #Währung : #Nachname #Vorname '}.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: . ''}.
		{ #Mitgliedsnummer . #val: . '' } .
		{ #AbrechnungVon . #date: . Date current }.		
		{ #AbrechnungBis . #date: . Date current}.
		{ #Betrag . #no: . 0}.
		{ #Währung . #val: . 'EUR'} .
		{ #AbrechnungVon . #date: . Date current}.				
	} 
! !

!Rechnungen class methodsFor: 'declaratives' stamp: 'hk 8/25/2016 18:19'!
rechnungspositionDeclarative
	^GbtDeclarative newStruct: 'Rechnungsposition' define: { 
		{ #summary . '#Nachname , #Vorname : #Betrag #Währung' }.
		{ #Nachname }.
		{ #Vorname }.
		{ #Mitgliedsnummer } .
		{ #AbrechnungVon }.		
		{ #AbrechnungBis }.
		{ #Betrag }.
		{ #Währung } .
		{ #AbrechnungVon . #tag: . #Berechnungsdatum }.				
	} 
! !

Object subclass: #Kommunikation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Object subclass: #Stammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Boote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Boote class methodsFor: 'things' stamp: 'hk 11/30/2016 13:52'!
boot
	"self boot edit"
	^GbtThing newStruct: 'Boot' define: {
		{ #summary . '#bizId : #Bootsname'  }.
		{ #idNumberPolicy . #BootNoPolicy }.
		{ #Bootstyp . #enum: .  #(Einer Zweier Dreier Vierer Fünfer Achter)}.
		{ #Bootsname . #val: . ''}.
		{ #MannschaftAnzahlMax . #no: . 1}.
	} full: { 
		{ #Steuermann . #enum: .  #(mit ohne)}.
		{ #Baujahr . #val: .  ''}.
	}! !

!Boote class methodsFor: 'testData' stamp: 'hk 11/30/2016 13:45'!
boot01
	"self boot01 edit"
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Wisch' ;	
		Bootstyp: #Einer;
		MannschaftAnzahlMax: 1;	
		Steuermann: #ohne;
		Baujahr: 2001;
		yourself

! !

!Boote class methodsFor: 'testData' stamp: 'hk 11/30/2016 13:45'!
boot02
	"self boot02 edit"
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Alster' ;	
		Bootstyp: #Zweier;
		MannschaftAnzahlMax: 3;	
		Steuermann: #mit;
		Baujahr: 1964;
		yourself

! !

!Boote class methodsFor: 'testData' stamp: 'hk 11/30/2016 13:45'!
boot03
	"self boot03 edit"
	^self boot
		bizId: self nextBizID;
		Bootsname: 'Elbe' ;	
		Bootstyp: #Zweier;
		MannschaftAnzahlMax: 2;	
		Steuermann: #ohne;
		Baujahr: 1980;
		yourself

! !

!Boote class methodsFor: 'contexts' stamp: 'hk 11/7/2016 17:02'!
bootContext: userName 
	"comment stating purpose of message"
	
	^GbtPlainAC newStruct: 'BootContext'  for: userName define: {
		{#displayAs: . 'Boot'  } .
		{#uiSpec:icon: . #GbtItemUI . #rowingBoat}
		}
! !

!Boote class methodsFor: 'contexts' stamp: 'hk 11/14/2016 18:13'!
booteContext: userName 
	""
	^GbtBigListAC newStruct: 'BooteContext'  for: userName define: {
		{#displayAs: . 'Boote'} .
		{#noPolicyPrefix: . 'Boot'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #rowingBoat} .
		{#templates: . self boot} .
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Bootsname Boot) #(Bootstyp Typ) #(Steuermann Steuermann))} .
		{#subcontext: . self bootContext: userName }
		}

! !

!Boote class methodsFor: 'testData' stamp: 'hk 1/26/2017 18:33'!
booteListe1
	"Diese Methode erzeugt die noPolicy für Boote vorab"
	GbtAppService default contextNoPolicyOf: #BooteContext prefix: #Boot.
	self boot01 store.
	self boot02 store.
	self boot03 store! !

!Boote class methodsFor: 'example' stamp: 'hk 1/26/2017 18:33'!
exampleRun
	GbtAppService initialize. GbtSVO initialize.
	(self booteContext: '') ui title: #Boote; open! !

!Boote class methodsFor: 'testData' stamp: 'hk 1/26/2017 18:33'!
nextBizID
	^GbtAppService default nextIdOfContextNoPolicy: #BooteContext! !

Stammdaten subclass: #FahrtenabzeichenStammdaten
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

Stammdaten subclass: #Personen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Personen class methodsFor: 'things' stamp: 'CC 7/8/2016 21:59'!
eMail
	"self eMail edit"
	
	^GbtThing newStruct: 'EMail' define: {
		{ #purposes .   #(Privat Arbeit)}.
		{ #summary .  '#EMail'}.
		{ #EMail . #val: . 'EMail'}.	
 	} full: {  
	}! !

!Personen class methodsFor: 'examples' stamp: 'hk 1/26/2017 18:33'!
exampleRun
	| ui |
	GbtAppService initialize. GbtSVO initialize.
	(ui := (self personenContext: '') ui) title: ('Sportler und Mitglieder', ui title); open! !

!Personen class methodsFor: 'things' stamp: 'CC 8/5/2016 17:06'!
kontaktdaten
	"self kontaktdaten edit"
	
	^GbtThing newStruct: 'Kontaktdaten' define: {
		{ #summary .  'EMail: #EMail Tel: #telNo'}.	
	} full: { 
		{ #StraßeUndNummer . #val: . ''}.
		{ #PLZUndWohnort . #val: .  ''}.
		{ #Kommunikation . #listOf: .  {self telNo . self eMail} }.
	}! !

!Personen class methodsFor: 'things' stamp: 'hk 8/31/2016 13:29'!
kontoDaten
	"self kontoDaten edit"
	
	^GbtThing newStruct: 'KontoDaten' define: {
		{ #summary .  '#Kontoinhaber'}.	
	} full: { 
		{ #Kontoinhaber . #calc: . '#Vorname #Nachname' }.
		{ #IBAN . #val: .  ''}.
		{ #BIC . #val: . ''}.
	}! !

!Personen class methodsFor: 'things' stamp: 'CC 8/30/2016 15:08'!
mitglied
	"self mitglied edit"
	
	^GbtThing newStruct: 'Mitglied' define: {
		{ #summary .  '#bizId : #Mitgliedstatus #Beitragstatus'}.	
		{ #idNumberPolicy . #MitgliedNoPolicy }.
		{ #GebDatum . #date: . Date current }.	
		{ #Mitgliedstatus . #enum: .  #(aktiv passiv) }.	
		{ #Beitragstatus . #enum: . #(Erwachsener 'Nichtverdiener14+' 'Kind14-')}.	
		{ #FamilienOberhaupt . #enum: . #(false true) }.	
		{ #FamilienmitgliedNr . #no: . 1 }.	
		{ #MitgliedSeit . #date: . Date current}.
	} full: { 	
		{ #Beruf . #val: . ''}.	
		{ #Familienname . #val: . ''}.
		{ #FamilienNummer . #val: . 'bizId Oberhaupt'}.			
		{ #Familienmitglieder . #enum: . #() }.	"list of MitgliedBizIds if Familienoberhaupt"
		{ #FahrtenabzeichenStatus . #enum: .  #('M18max' 'W18max' 'M18plus' 'W18plus') }.	
		{ #Schnuppermitglied . #enum: . #(false true) }.	
		{ #Austrittserklärung . #date: . Date current}.
		{ #Austritt . #calc: . '(( #Austrittserklärung  = ''nil'') not ) ifTrue: [ ( #Schnuppermitglied asString = ''true'') ifTrue: [ #MitgliedSeit asDate addMonths: 3 ] ifFalse: [ Date year: (Date current year) month: 12 day: 31 ]]'}.
		"Business rule short in Excel-style:  
		if(#Austrittserklärung = nil; if(#Schnuppermitglied; plusTime (#MitgliedSeit;0;3;0); datum(31;12;jahr(Austrittserklärung)))) "
		{ #KontoDaten . #thing: . self kontoDaten}.		
		{ #Beitragsrechnung . #listOf: . Rechnungen rechnung}.	
		{ #BeitragsSonderregelung . #enum: . #(false true) }.
		{ #Abrechnungsperiode . #enum: . #(jährlich halbjährlich monatlich sonstiges) }.	
"		{ #Ehrungen . #listOf: . { self drvFahrtenabzeichen . self kilometerpreis } }."	
	}

		! !

!Personen class methodsFor: 'test data' stamp: 'hk 1/26/2017 18:33'!
nextBizID
	^GbtAppService default nextIdOfContextNoPolicy: #PersonenContext
! !

!Personen class methodsFor: 'things' stamp: 'CC 7/22/2016 10:50'!
person
	"self person edit"
	
	^GbtThing newStruct: 'Person' define: {
		{ #summary .  '#bizId : #Vorname #Nachname'}.	
		{ #idNumberPolicy . #SportlerNoPolicy }.
		{ #Nachname . #val: . ''}.
		{ #Vorname . #val: .  ''}.
		{ #Vorname2 . #val: . ''}.	
		} full: { 
		{ #Kontaktdaten . #thing: . self kontaktdaten }.	
		{ #Sportler . #thing: . self sportlerdaten}.	
		{ #mitglied . #thing: . self mitglied}.		
	}! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/29/2016 16:39'!
person01
	"self person01 editD"

	| m p |
	p := self person .
	m := p mitglied.
	m GebDatum: '08.06.1954' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #true.	
	m FamilienmitgliedNr: 1.	
	m MitgliedSeit: '01.01.1967'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Kaufmann'.
	m Familienname: 'Schmidt'.
	m KontoDaten IBAN: 'DE1234567890'.
	m KontoDaten BIC:'XYZABC'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Henning.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/30/2016 18:02'!
person02
	"self person02  editD"

	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.07.1961' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 2.	
	m MitgliedSeit: '01.15.1993'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Buchhändlerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Christel.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/30/2016 18:02'!
person03
	"self person03 editD"

	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '03.10.1996' .	
	m Mitgliedstatus: #aktiv .	
	m Beitragstatus: #Nichtverdiener14plus .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 3.	
	m MitgliedSeit: '01.01.2007'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Schülerin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Imke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'test data' stamp: 'hk 11/30/2016 18:02'!
person04
	"self person04 editD"

	| m  p |
	p := self person .
	m := p mitglied.
	m GebDatum: '10.10.1989' .	
	m Mitgliedstatus: #passiv .	
	m Beitragstatus: #Erwachsener .	
	m FamilienOberhaupt: #false.	
	m FamilienmitgliedNr: 4.	
	m MitgliedSeit: '01.01.2000'.
	m Familienname: #Schmidt .
	m BeitragsSonderregelung: #false .
	m Abrechnungsperiode: #jährlich.	
	m Beruf:'Sozialpädagogin'.
	m Familienname: 'Schmidt'.
	m FamilienNummer: 'Sportler1'.
	m Abrechnungsperiode: #jährlich.
	
	p Nachname: #Schmidt .
	p Vorname: #Levke.
	p Kontaktdaten StraßeUndNummer: 'Rethfelder Str 48'.
	p Kontaktdaten PLZUndWohnort: '25336 Elmshorn'.
	(p Kommunikation) newEntry: ( self telNo TelNr: '04121 48839'; yourself)  with: 'Privat'.
	p Kommunikation newEntry: (self eMail EMail:'schmidt@gmail.com'; yourself) with: 'Privat'.
	
	^p
! !

!Personen class methodsFor: 'contexts' stamp: 'hk 12/14/2016 16:55'!
personContext: userName 	
	^GbtPlainAC newStruct: 'PersonContext'  for: userName define: {
		{#displayAs: . 'Person'  } .
		{#uiSpec:icon: . #GbtItemUI . #rower}.
		}! !

!Personen class methodsFor: 'contexts' stamp: 'hk 11/14/2016 18:12'!
personenContext: userName 
	^GbtBigListAC newStruct: 'PersonenContext'  for: userName define: {
		{#displayAs: . 'Personen'} .
		{#noPolicyPrefix: . 'Sportler'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #rower} .
		{#templates: . self person} .
"		{#loadPolicy: . #simpleload } ."
		{#loadPolicy: . #autoload } .
		{#display: . #( #(Nachname Name) #(Vorname Vorname))} .
		{#subcontext: . self personContext: userName}
		}
! !

!Personen class methodsFor: 'test data' stamp: 'hk 1/26/2017 18:33'!
personenListe1
	"Diese Methode erzeugt die noPolicy für Personen vorab"
	|  p  |
	GbtAppService default contextNoPolicyOf: #PersonenContext prefix: #Sportler.
	1 to: 10 do: [ :n | p := self person01 bizId: self nextBizID. p Nachname: 'Schmidt',n printString. p store ].
	1 to: 1 do: [ :n |  p := self person02 bizId: self nextBizID. p Nachname: 'Schmidt',n printString. p store ].
	1 to: 1 do: [ :n |  p := self person03 bizId: self nextBizID. p Nachname: 'Schmidt',n printString. p store ].
	1 to: 1 do: [ :n |  p := self person04 bizId: self nextBizID. p Nachname: 'Schmidt',n printString. p store ].! !

!Personen class methodsFor: 'things' stamp: 'hk 11/8/2016 20:06'!
sportlerdaten
	"self sportlerdaten  edit"
	
	^GbtThing newStruct: 'Sportlerdaten' define: { 
		{ #summary . 'system template' }.
	} full: { 
		{ #Fremdverein . #val: . ''}.
		{ #Bemerkungen . #text: . ''}.
	}! !

!Personen class methodsFor: 'things' stamp: 'hk 11/8/2016 20:06'!
telNo
	"self telNo edit"
	
	^GbtThing newStruct: 'TelNo' define: {
		{ #purposes .   #(mobileprivat mobilarbeit Privat Arbeit Fax )}.
		{ #summary .  '#TelNr'}.
		{ #TelNr . #val: . 'Telefonnummer'}.	
 	} ! !

Object subclass: #Statistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_EFA'!

!Statistics class methodsFor: 'contexts' stamp: 'hk 9/30/2016 14:56'!
createGlobals
	self ergebnisDecl .
	self transformStatisticDecl.  
	self kmStatisticBoote .
	self kmStatisticRuderer .
! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:20'!
ergebnis
	"self ergebnis edit"
	^GbtThing newStruct: 'Ergebnis' define: {
		{ #summary . 'km-Statistik' }.
		{ #FahrtID . #val: . '' }.
		{ #Datum . #date: . Date today}.
		{ #Bootsname . #val: . '' }.
		{ #RudererName . #val: . '' }.
		{ #Kilometer . #val: . '' }.
		{ #Abfahrt . #date: . Date today}.
		{ #Ankunft . #date: . Date today}.
		{ #Ziel . #val: . '' }.
	}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 11/7/2016 19:26'!
ergebnisContext: userName 
	^GbtPlainAC newStruct: 'ErgebnisContext' for: userName define: {
		{#displayAs: . 'Ergebnis'  } .
		{#uiSpec:icon: . #GbtItemUI . #statistics}}! !

!Statistics class methodsFor: 'declaratives' stamp: 'hk 9/27/2016 11:22'!
ergebnisDecl
	"Ergebnis-Declarative copies the fields from Fahrt"
	
	^GbtDeclarative newStruct: 'Ergebnis' define: {
		{ #FahrtID . #tag: . #bizId }.
		{ #Bootsname }.
		{ #RudererName }.
		{ #Kilometer }.
		{ #Abfahrt }.
		{ #Ankunft }.
		{ #Ziel }.
	}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 11/7/2016 19:27'!
ergebnisseContext: userName 
	^GbtUlistAC newStruct: 'ErgebnisseContext'  for: userName define: {
		{#displayAs: . 'Ergebnisse'  } .
		{#uiSpec:icon: . #GbtListAndItemUI . #statistics}.
		{#template:for: . self ergebnis . #resultList } .
		{#display: . #(FahrtID Datum Abfahrt Ankunft Ziel Bootsname RudererName Kilometer)} .
		{#subcontext: . self ergebnisContext: userName}.
		}! !

!Statistics class methodsFor: 'things' stamp: 'hk 10/13/2016 21:17'!
fahrtenConstraint
	"self fahrtenConstraint editD"

	^GbtThing newStruct: 'FahrtenConstraint' define: { 
		{ #begin . #date: .  '1.1.2016' }.
		{ #end . #date: .  '12.31.2016' }.
		{ #gtBegin . #constraint: . '#Abfahrt asDate > #begin asDate'} .
		{ #ltEnd . #constraint: . '#Ankunft asDate < #end asDate'}.
		{ #boot . #val: .  ''}.
		{ #welches . #constraint: . '#Bootsname = #boot'}.
		{ #ruderer . #val: .  ''}.
		{ #fahrtenBesatzung . #ref: . #Besatzung}.
		{ #wer . #constraint: . '(GbtThing definedAs: #fahrtenBesatzung ) contains: #ruderer at: ''RudererName'''}.
	}.
! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 15:39'!
kmStatistic
	"self kmStatistic editD"

	^GbtThing newStruct: 'KmStatistic' define: {
	 	{ #summary . 'km-statistik' }.
		{ #idNumberPolicy . #StatistikNoPolicy }.
		{ #datum . #date: . Date today}.
		{ #km . #sum: .  #Kilometer }.
		{ #startList . #enum: .  #(BooteContext PersonenContext) }.
		{ #resultList . #listOf: . self ergebnis}.
		{ #constraints . #thing: . self fahrtenConstraint}.
	}! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:09'!
kmStatisticBoote
	"self kmStatisticBoote editD"
	
	| constraint |
	constraint := (self fahrtenConstraint copyWithName: #BooteConstraint)
		define: #begin date:  '1.1.2016' ;
		define: #end  date: '12.31.2016' ;
		removeSmart: #wer;		"darf nicht nach Ruderern fragen"
		yourself.
	
	^(self kmStatistic copyWithName: #KmStatisticBoote)
		summary: 'Boote-Statistik';
		define: #startList val: #BooteContext ;		"startet mit der Booteliste"
		define: #constraints thing: constraint;
		yourself

! !

!Statistics class methodsFor: 'things' stamp: 'hk 9/30/2016 16:09'!
kmStatisticRuderer
	"self kmStatisticRuderer editD"
	
	| constraint |
	constraint := (self fahrtenConstraint copyWithName: #RudererConstraint)
		define: #begin date:  '1.1.2016' ;
		define: #end  date: '12.31.2016' ;
		removeSmart: #welches;	"darf nicht nach Booten fragen"
		yourself.
	
	^(self kmStatistic copyWithName: #KmStatisticRuderer)
		summary: 'Ruderer-Statistik';
		define: #startList val: #PersonenContext ;		"startet mit der Personenliste"
		define: #constraints thing: constraint;
		yourself

! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 12/16/2016 18:31'!
statisticContext: userName
	^ GbtPlainAC newStruct: 'StatisticContext' for: userName define:
			{{#displayAs: . 'Statistik'}.
			{#uiSpec:icon: . #GbtItemWithTabsUI . #statistics}.
			{#aspect:on:. self ergebnisseContext: userName. #resultList}.
			{#menu: . #'km-Statistik'}.
			{#behavior:actions:. #'km-Statistik'.
				#(#ASSURETH #void 
				  #MAPBL #FahrtenBuchContext 
				  #READSLOT #(#constraints #vConstr) 
				  #FILTER #vConstr 
				  #ALTER #(#void #Ergebnis) 
				  #REDUCE #(#thing #resultList))}}! !

!Statistics class methodsFor: 'contexts' stamp: 'hk 12/16/2016 18:31'!
statisticsContext: userName 
	self createGlobals .
	
	^GbtBigListAC newStruct: 'StatisticsContext' for: userName  define: {
		{#displayAs: . 'Statistiken'} .
		{#noPolicyPrefix: . 'Stat'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #statistics} .
		{#templates: . self kmStatistic } .
		{#loadPolicy: . #simpleload } .
		{#display: . #(km ruderer boot datum begin end summary)} .
		{#subcontext: . self statisticContext: userName}.
		{#menu: . #'Run Statistics' }.
		{#behavior:actions: . #'Run Statistics' . 
			#(ASSIGN #( #(KmStatisticBoote KmStatisticRuderer) stats)
			ASKFROM #(stats thing)							"get the relevant statistics from user -> thing"
			READSLOT #(startList vBLc)					"read context name of big list -> vBLc"
			MAPBL vBLc 											"map big list of vBLc"
			ALTER  #(thing TransformStatistic) 			"transform all list elements using TransformStatisticDecl source: pipe thing (the template)"
			APPLY #(StatisticContext 'km-Statistik')	"apply behavior to all list elements"
			ADDBL StatisticsContext) }.						"add the result list"
	}
! !

!Statistics class methodsFor: 'declaratives' stamp: 'hk 10/3/2016 12:19'!
transformStatisticDecl
	"erzeugt die Statistiken aus den Elementen einer Liste von Personen / Booten und der Ausgangsstatistik"
	
	| constraint |	
	(self fahrtenConstraint copyWithName: #NewFahrtenConstraint)		"we want a filled constraint for further editing/evaluations"
		removeSmart: #wer;
		removeSmart: #welches.
	constraint := GbtDeclarative newStruct: 'NewFahrtenConstraint' define: {
		{ #begin }.
		{ #end }.
		{ #gtBegin } .
		{ #ltEnd }.
		{ #boot . #tag: . #Bootsname}.
		{ #welches }.
		{ #ruderer . #tag: . #Nachname}.
		{ #fahrtenBesatzung }.
		{ #wer }.
	}.
	self kmStatistic copyWithName: #TransformStatistic.		"we need the bizId of a new kmStatistic"
	^GbtDeclarative newStruct: 'TransformStatistic' define: {
	 	{ #summary }.
		{ #idNumberPolicy }.
		{ #datum }.
		{ #km }.
		{ #startList }.
		{ #resultList }.
		{ #constraints . #decl: . constraint }
	} ! !
